<?php

// +-----------------------------------------------------------------------+
// | Delete Hit/Rate plugin for piwigo  by TEMMII                          |
// +-----------------------------------------------------------------------+
// | Copyright(C) 2011-2021 ddtddt               http://temmii.com/piwigo/ |
// +-----------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or modify  |
// | it under the terms of the GNU General Public License as published by  |
// | the Free Software Foundation                                          |
// |                                                                       |
// | This program is distributed in the hope that it will be useful, but   |
// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
// | General Public License for more details.                              |
// |                                                                       |
// | You should have received a copy of the GNU General Public License     |
// | along with this program; if not, write to the Free Software           |
// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
// | USA.                                                                  |
// +-----------------------------------------------------------------------+

if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');

define('PDHR_DIR' , basename(dirname(__FILE__)));
define('PDHR_PATH' , PHPWG_PLUGINS_PATH . PDHR_DIR . '/');
load_language('plugin.lang', PDHR_PATH);
define('PDHR_ADMIN',get_root_url().'admin.php?page=plugin-'.PDHR_DIR);

/*add_event_handler('get_admin_plugin_menu_links', 'dphr_admin_menu');
function dphr_admin_menu($menu){
  load_language('plugin.lang', PDHR_PATH);
  $menu[] = array(
    'NAME' => l10n('Delete Hit/Rate'),
    'URL' => PDHR_ADMIN,
  );
  return $menu;
}*/

//add prefiltre photo
add_event_handler('loc_begin_admin', 'plugdphrPf',60);
add_event_handler('loc_begin_admin', 'plugdphrPf2',60);

function plugdphrPf()
  {
  global $template;
  $admin_base_url = $_SERVER['REQUEST_URI'];
  $template->set_prefilter('picture_modify', 'plugdphrPT');
 $template->assign(
    array(
		'U_DELETEPHIT' => $admin_base_url . '&amp;deletephit',
		'U_DELETEPRATE' => $admin_base_url . '&amp;deleteprate',
  ));
  }

function plugdphrPT($content, &$smarty)
	{
load_language('plugin.lang', PDHR_PATH);
  $search = "#        </div>
      </div>
    </div>


    <p>
      <strong>#";
  
  $replacement = '        </div>
      </div>
    </div>


    <p>
      <strong>
	<a class="icon-trash mouse" href="{$U_DELETEPHIT}" onclick="return confirm(\'{\'Are you sure?\'|@translate|@escape:javascript}\');">{\'Purge hit of the photo\'|@translate}</a><br>
	<a class="icon-trash mouse" href="{$U_DELETEPRATE}" onclick="return confirm(\'{\'Are you sure?\'|@translate|@escape:javascript}\');">{\'Purge rate of the photo\'|@translate}</a><br><br>
  ';

  return preg_replace($search, $replacement, $content);
	}
		
function plugdphrPf2()
	{
if (isset($_GET['deletephit'])) {
  $admin_base_url=explode('&deletephit', $_SERVER['REQUEST_URI']);
  $photoid = explode('photo-', $_SERVER['REQUEST_URI']);
  if(strstr($photoid[1], '-properties')){$photoid = explode('-properties', $photoid[1]);}
  else if(strstr($photoid[1], '&cat')){$photoid = explode('&cat', $photoid[1]);}
  else{
  $_SESSION['page_infos'] = array('error');
  redirect($_SERVER['REQUEST_URI']);
  }
  $_SESSION['page_infos'] = $admin_base_url;
  $query = 'UPDATE ' . IMAGES_TABLE . ' SET hit= \'0\' WHERE id = '.$photoid[0].';';
  $result = pwg_query($query);
  redirect($admin_base_url[0]);
} 

if (isset($_GET['deleteprate'])) {
  $admin_base_url=explode('&deleteprate', $_SERVER['REQUEST_URI']);
  $photoid = explode('photo-', $_SERVER['REQUEST_URI']);
  if(strstr($photoid[1], '-properties')){$photoid = explode('-properties', $photoid[1]);}
  else if(strstr($photoid[1], '&cat')){$photoid = explode('&cat', $photoid[1]);}
  else{
  $_SESSION['page_infos'] = array('error');
  redirect($_SERVER['REQUEST_URI']);
  }
  $query = 'UPDATE ' . IMAGES_TABLE . ' SET rating_score = NULL WHERE id = '.$photoid[0].';';
  $result = pwg_query($query);
  $query = 'DELETE FROM ' . RATE_TABLE . ' WHERE element_id = '.$photoid[0].';';
  $result = pwg_query($query);
  redirect($admin_base_url[0]);
}

  }
  
//add prefiltre album
add_event_handler('loc_end_cat_modify', 'plugdphrAf');
add_event_handler('loc_end_cat_modify', 'plugdphrAf2');

function plugdphrAf()
 {
	global $template;
	$admin_base_url = $_SERVER['REQUEST_URI'];
	$template->set_prefilter('album_properties', 'plugdphrAT');
	$template->assign(
    array(
		'U_DELETEAHIT' => $admin_base_url . '&amp;deleteahit',
		'U_DELETEARATE' => $admin_base_url . '&amp;deletearate',
  ));
 }

function plugdphrAT($content, &$smarty)
 {
load_language('plugin.lang', PDHR_PATH);
  $search = '#      </div>
    </div>

    <div class="catLock">#';
  
  $replacement = '
			<a class="icon-trash mouse" href="{$U_DELETEAHIT}" onclick="return confirm(\'{\'Are you sure?\'|@translate|@escape:javascript}\');">{\'Purge hits on all pictures album\'|@translate}</a>
			<a class="icon-trash mouse" href="{$U_DELETEARATE}" onclick="return confirm(\'{\'Are you sure?\'|@translate|@escape:javascript}\');">{\'Purge rates on all pictures album\'|@translate}</a>
		        </div>
    </div>

    <div class="catLock">
  ';

  return preg_replace($search, $replacement, $content);
 }
 
 function plugdphrAf2()
 {
 
if (isset($_GET['deleteahit'])) {
  $admin_base_url=explode('&deleteahit', $_SERVER['REQUEST_URI']);
  $albumid = explode('album-', $_SERVER['REQUEST_URI']);
  if(strstr($albumid[1], '-properties')){
    $albumid = explode('-properties', $albumid[1]);
	$albumid = $albumid[0];
  }  else if(strstr($albumid[1], '&deleteahit')){
    $albumid = explode('&deleteahit', $albumid[1]);
	$albumid = $albumid[0];
	}
  else{
  $_SESSION['page_infos'] = array('error');
  redirect($_SERVER['REQUEST_URI']);
  }
  $query = 'select image_id FROM ' . IMAGE_CATEGORY_TABLE . ' WHERE category_id = '.$albumid.';';
  $result = pwg_query($query);
  $delval = array();
  while($row = pwg_db_fetch_assoc($result))
	{
    array_push($delval, $row['image_id']);
	}
  foreach ($delval as $delrate)
	{
 	$query = 'UPDATE ' . IMAGES_TABLE . ' SET hit= \'0\' WHERE id = \''.$delrate.'\';';
	$result = pwg_query($query);
	}
  redirect($admin_base_url[0]);
} 
 
if (isset($_GET['deletearate'])) {
  $admin_base_url=explode('&deletearate', $_SERVER['REQUEST_URI']);
  $albumid = explode('album-', $_SERVER['REQUEST_URI']);
  if(strstr($albumid[1], '-properties')){
    $albumid = explode('-properties', $albumid[1]);
	$albumid = $albumid[0];
  }  else if(strstr($albumid[1], '&deletearate')){
    $albumid = explode('&deletearate', $albumid[1]);
	$albumid = $albumid[0];
	}
  else{
  $_SESSION['page_infos'] = array('error');
  redirect($_SERVER['REQUEST_URI']);
  }
  $query = 'select image_id FROM ' . IMAGE_CATEGORY_TABLE . ' WHERE category_id = '.$albumid.';';
  $result = pwg_query($query);
  $delval = array();
  while($row = pwg_db_fetch_assoc($result))
	{
    array_push($delval, $row['image_id']);
	}
  foreach ($delval as $delrate)
	{
	$query = 'UPDATE ' . IMAGES_TABLE . ' SET rating_score = NULL WHERE id = \''.$delrate.'\';';
	$result = pwg_query($query);
	
	$query = 'DELETE FROM ' . RATE_TABLE . ' WHERE element_id = \''.$delrate.'\';';
	$result = pwg_query($query);
	}
  redirect($admin_base_url[0]);
} 

}
?>